/*
 * $RCSfile: debugging.h,v $
 * $Author: swaj $
 * $Revision: 1.6 $
 */

/*
 * Was written by Alexey Semenoff (c) 2001-2006
 * See COPYING for copying policy
 */


#ifndef __DEBUGGING_H_
#define __DEBUGGING_H_ 1

#ifndef __DBG_TARGET_
#define __DBG_TARGET_ stderr
#endif




#if defined (__STDC_VERSION__) && !defined(OLD_GNUC)

#define noDBG(...)

#elif defined (__GNUC__)

#define noDBG(format...)

#else  /* ! __GNUC__ */

#ifndef __noDBG__
#define __noDBG__ 1

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

	static void noDBG(const char *format, ...) { }


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __noDBG__ */


#endif /* __GNUC__ */ 










#ifndef DEBUG /* ! DEBUG */ /* P R O D U C T I O N */


#if defined (__STDC_VERSION__) && !defined(OLD_GNUC)

#define DBG(...)

#elif defined (__GNUC__)

#define DBG(format...)

#else  /* ! __GNUC__ */

#ifndef __DBG__
#define __DBG__ 1

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

	static void DBG(const char *format, ...) { }

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __DBG__ */


#endif /* __GNUC__ */ 



#else /* DEBUG  */ /* D E B U G */



#if defined (__STDC_VERSION__) && !defined(OLD_GNUC)


#define DBG(...) \
        fprintf (__DBG_TARGET_, "DBG {%s:%d (%s)} >", __FILE__, __LINE__, __PRETTY_FUNCTION__ ); \
        fprintf (__DBG_TARGET_, __VA_ARGS__ ); \
        fprintf (__DBG_TARGET_, "<\n");

#elif defined (__GNUC__)

#define DBG(format...) \
        fprintf (__DBG_TARGET_, "DBG {%s:%d} >", __FILE__, __LINE__ ); \
        fprintf (__DBG_TARGET_, format); \
        fprintf (__DBG_TARGET_, "<\n");

#else /* ! __GNUC__ */

#ifndef __DBG__
#define __DBG__ 1


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

static void DBG(const char *format, ...)
{
	va_list args;
	fprintf (__DBG_TARGET_, "%s >> file %s: line %d >", __T, __FILE__,__LINE__);
	va_start(args, format);
	fprintf (__DBG_TARGET_,format);
	va_end(args);
	fprintf (__DBG_TARGET_,"<\n");
}

#ifdef __cplusplus
}
#endif

#endif /* __DBG__ */


#endif /* __GNUC__ */

#endif /* DEBUG */





#endif /* __DEBUGGING_H_ */



/* __END__ */
