/*
 * $RCSfile: sdict-main.h,v $
 * $Author: swaj $
 * $Revision: 1.2 $
 */

/*
 * Was written by Alexey Semenoff (c) 2001-2006
 * See COPYING for copyiright policy
 */


#ifndef __SDICT_MAIN_H_
#define __SDICT_MAIN_H_ 1



#define OUTPUT stderr



#ifdef __SDICT_MAIN_C /* private */

struct termios saved_tio, work_tio;

#define INPUT_STRING_LEN 128

#define BACKSPACE 0x7f
#define TABULATION 0x9


static uchar input_string[INPUT_STRING_LEN*6 + 1];
static int input_string_pos=0;  

#define PROMPT_SIZE 20

static uchar prompt[PROMPT_SIZE +1];


#define SET_PROMPT(__a) strncpy(prompt, __a, sizeof(prompt) - 1)

#define DEFAULT_PROMPT "sdict>"


typedef struct {
	char keyb_c;
	uint8_t mapping[7];
} KeyMapping;


KeyMapping la[] = {
#include "la.tbl"
	{ 0, "" }};

KeyMapping fi[] = {
#include "fi.tbl"
	{ 0, "" }};

KeyMapping ru[] = {
#include "koi8.tbl"
	{ 0, "" }};

KeyMapping *which_km = fi;



/* commands */
#define COMMAND_STR_MAX 64

#define C_STR_QUIT	"quit"
#define C_STR_QUIT_S	"q"
#define C_STR_HELP	"help"
#define C_STR_KBLA	"kb la"
#define C_STR_KBLA_S	"kl"
#define C_STR_KBRU	"kb ru"
#define C_STR_KBRU_S	"kr"
#define C_STR_LOAD	"load"
#define C_STR_LOAD_S	"l"
#define C_STR_INFO	"info"
#define C_STR_INFO_S	"i"
#define C_STR_EXT	"!"

#define C_ILL		0
#define C_QUIT		1
#define C_HELP		2
#define C_KBLA		3
#define C_KBRU		4
#define C_LOAD		5
#define C_INFO		6
#define C_EXT		7


typedef struct  {
        char command_s[COMMAND_STR_MAX];
        int command_no;
} Commands;

static Commands cmds[] = {
	{ C_STR_QUIT,	C_QUIT	},
	{ C_STR_QUIT_S,	C_QUIT	},
	{ C_STR_HELP,	C_HELP	},
	{ C_STR_KBLA,	C_KBLA	},
	{ C_STR_KBLA_S,	C_KBLA	},
	{ C_STR_KBRU,	C_KBRU	},
	{ C_STR_KBRU_S,	C_KBRU	},
	{ C_STR_LOAD,	C_LOAD	},
	{ C_STR_LOAD_S,	C_LOAD	},
	{ C_STR_INFO,	C_INFO	},
	{ C_STR_INFO_S,	C_INFO	},
	{ C_STR_EXT,	C_EXT	},
	{ "",           C_ILL  },
};


/* Sdict .dct stuff */

static Sdict *sdict=NULL;
static int dct_loaded=0;




#endif /*  __SDICT_MAIN_C  private */





#endif /* __SDICT_MAIN_H_ */



/* __END__ */





