/*
 * $RCSfile: testtest.c,v $
 * $Author: swaj $
 * $Revision: 1.12 $  
 */

/*
 * Was written by Alexey Semenoff (c) 2001-2006
 * See COPYING for copyiright policy
 */

#define _GNU_SOURCE

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdint.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <fcntl.h>
#include <unistd.h>


#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "defines.h"
#include "debugging.h"

#include "libunicode.h"
#include "libsdict.h"


#define TEST_DCT "file.dct"


int main (void)
{
//	uchar uuu[] = "1234567890ЙЦУКЕНГШЩЗ";
//	int l1, l2, l3;
//	pointer p;

	FILE *fl;
	int rv;
	Sdict *sdict;
/*

	l1 = strlen(uuu);
	l2 = utf8_strlen(uuu);
	DBG("strlen() = %d, utf8_strlen() = %d", l1, l2  );
	p = utf8_to_utf16(uuu);
	l3 = utf16_strlen(p);
	DBG("utf16_strlen() = %d", l3 );
*/

	sdict = sdict_new (0,0);
	unless (sdict) {
		DBG("unable create sdict");
		exit (1);
	}

	fl = fopen (TEST_DCT, "r");
	if (!fl) {
		DBG("fopen failed");
		exit (1);
	}

	//rv = sdict_load_dictionary (sdict, TEST_DCT);
	rv = sdict_load_dictionary_file (sdict, fl);


	if (rv != RET_SUCCESS) {
		DBG("unable load dictionary");
		exit (1);
	}


	rv = sdict_get_next_word(sdict);
	sdict_get_article(sdict);
	DBG("article = >%s<",  sdict_get_last_article (sdict) );



/*
	while (1) {
		rv = sdict_get_next_word(sdict);
		if (rv != RET_SUCCESS) break;
	}


	while (1) {
		rv = sdict_get_prev_word(sdict);
		if (rv != RET_SUCCESS) break;
	}
*/


	rv = sdict_find_word(sdict, "fuck off");

	DBG("sdict_find_word() = %d", rv);

	if (rv == RET_SUCCESS) {
		DBG("word  = >%s<", sdict_get_last_word (sdict) );
		DBG("article = >%s<",  sdict_get_last_article (sdict) );
	}



	rv = sdict_seek_word(sdict, "do");
	DBG("sdict_seek_word() = %d", rv);


	if (rv == RET_SUCCESS) {
		sdict_get_next_word(sdict);
		DBG("word  = >%s<", sdict_get_last_word (sdict) );
	}

	rv = sdict_rewind (sdict);
	DBG("sdict_rewind() = %d", rv);

	rv = sdict_get_next_word(sdict);
	DBG("sdict_get_next_word() = %d", rv);
	if (rv == RET_SUCCESS) {
		DBG("word  = >%s<", sdict_get_last_word (sdict) );
	}


	rv =  sdict_seek_to (sdict, 500);
	DBG("sdict_seek_to(500) = %d", rv);

	rv = sdict_get_next_word(sdict);
	DBG("sdict_get_next_word() = %d", rv);
	if (rv == RET_SUCCESS) {
		DBG("word  = >%s<", sdict_get_last_word (sdict) );
	}


	rv = sdict_get_position (sdict);

	DBG("sdict_get_position() = %d", rv);

/*

	rv =  sdict_seek_to (sdict, 1000);
	DBG("sdict_seek_to(1000) = %d", rv);

	rv = sdict_get_next_word(sdict);
	DBG("sdict_get_next_word() = %d", rv);
	if (rv == RET_SUCCESS) {
		DBG("word  = >%s<", sdict->last_word);
	}


	rv = sdict_get_next_word(sdict);
	DBG("sdict_get_next_word() = %d", rv);
	if (rv == RET_SUCCESS) {
		DBG("word  = >%s<", sdict->last_word);
	}

*/

	sdict_unload_dictionary(sdict);

	sdict_del(sdict);

	exit (0);
}



/* __END__ */
