/*
 * $RCSfile: testtest.c,v $
 * $Author: swaj $
 * $Revision: 1.6 $
 */

/*
 * Was written by Alexey Semenoff (c) 2001-2006
 * See COPYING for copyiright policy
 */

/*
 * short test to make sure if unzlib.c works
 */


#define _GNU_SOURCE

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "unzlib.h"


#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifndef DEBUG
#define DEBUG 1
#endif

#include "defines.h"
#include "debugging.h"


#define TESTFILE_Z  "testfile.z"

#define BUF_SIZE 1024


int main (void)
{
	uchar inbuf[BUF_SIZE];
	uchar /*Bytef*/ oubuf[BUF_SIZE];
	int /*uLongf*/ dlen;
	int fd;
	int rv,size;


	DBG("opening file '%s'", TESTFILE_Z);


	if ((fd=open(TESTFILE_Z, O_RDONLY)) < 0) {
		DBG("open() failed: '%s'", strerror(errno));
		exit (1);
	}

	DBG("reading from file into buffer");

	size = read(fd, inbuf, BUF_SIZE);

	DBG("read(), size = %d", size);
	
	close (fd);

	if (size <= 0) {
		DBG("resd() exits with an error");
		exit (1);
	}

	dlen = BUF_SIZE;

	rv = zuncompress (oubuf, (uLongf*)&dlen, inbuf, size);

	DBG("zuncompress(), rv = %d, dlen = %d", rv, (int)dlen);


	if (rv == Z_OK) {
		DBG("clear text is: '%s'", oubuf); 
	} else if (rv == Z_BUF_ERROR) {
		DBG("zuncompress() exits with an error, buffer too small");
		DBG("clear text is: '%s'", oubuf); 
	} else {
		DBG("zuncompress() exits with an error '%d'", rv);
	}


	exit (0);
}



/* __END__ */







